import { IBeforeSend, IContext, IEnvInfo, IFetch, IStorage, ISystemInfo, IView } from './types';
export declare const C_ClientID = "QMOC_clientId";
export declare const C_SessionID = "QMOC_sessionId";
export declare class OceanInstance {
    constructor(fetch: IFetch, systemInfo: ISystemInfo, envInfo: IEnvInfo, storage: IStorage, beforeSend?: IBeforeSend);
    private fetch;
    private storage;
    private beforeSend;
    private systemInfo;
    private envInfo;
    private oceanApi;
    private _clientID;
    setQmId(qmid: string): void;
    setShopId(shopId: string): void;
    /**
     * 如果缓存中有clientID则直接从clientID中拿,
     * 如果缓存中没有clientID则生成 且保存在缓存中,过期时间 the long the better;
     * @returns {string}
     */
    getClientId(): Promise<string>;
    /**
     * 如果缓存中有sessionId则直接从sessionId中拿;
     * 如果缓存中没有sessionId则生成;
     * session的时间控制交好缓存的过期机制来保证;
     * 每次使用都要更新下过期时间;
     * @returns {string}
     */
    getSessionId(): Promise<string>;
    /**
     *
     * @returns {Promise<string>}
     */
    private getAndUpdate(key, timeout);
    /**
     * 发布浏览记录请求;
     * @param {IViewRequest | IGoodsViewRequest} request
     */
    sendView(request: IView, context?: IContext): void;
    private _send(oceanRequest);
}
